#include <gtk/gtk.h>

static int state[3] = {0, 0, 0};

void checkstate(void)
{
    int sum;

    sum = state[0] + state[1] + state[2];
    switch (sum) {
	case 0:
	    break;
	case 1:
	    break;
	case 2:
	    g_print ("Come on.. press the last key!\n");
	    break;
	case 3:
	    g_print ("Bingo!\n");
	    system("/sbin/shutdown -t3 -a -r now\n");
	    break;
    }
}

/* Our new improved callback.  The data passed to this function is printed
 * to stdout. */

void ctrl_callback (GtkWidget *widget, gpointer data)
{
    if (GTK_TOGGLE_BUTTON (widget)->active)
    {
        /* If control reaches here, the toggle button is down */
    g_print ("Ctrl was pressed down\n", (char *) data);
    state[0] = 1;
    checkstate();

    } else {

    g_print ("Ctrl was released\n", (char *) data);
    state[0] = 0;
        /* If control reaches here, the toggle button is up */
    }
}

void alt_callback (GtkWidget *widget, gpointer data)
{
    if (GTK_TOGGLE_BUTTON (widget)->active)
    {
        /* If control reaches here, the toggle button is down */
    g_print ("Alt was pressed down\n", (char *) data);
    state[1] = 1;
    checkstate();

    } else {
    g_print ("Alt was released\n", (char *) data);
    state[1] = 0;
        /* If control reaches here, the toggle button is up */
    }
}

void del_callback (GtkWidget *widget, gpointer data)
{
    if (GTK_TOGGLE_BUTTON (widget)->active)
    {
        /* If control reaches here, the toggle button is down */
    g_print ("Del was pressed down\n", (char *) data);
    state[2] = 1;
    checkstate();

    } else {
    g_print ("Del was released\n", (char *) data);
    state[2] = 0;
        /* If control reaches here, the toggle button is up */
    }
}



/* another callback */
void delete_event (GtkWidget *widget, GdkEvent *event, gpointer data)
{
    gtk_main_quit ();
}

int main (int argc, char *argv[])
{
    /* GtkWidget is the storage type for widgets */
    GtkWidget *window;
    GtkWidget *button1;
    GtkWidget *button2;
    GtkWidget *button3;
    GtkWidget *box1;
    GtkTooltips *tooltips;

    /* this is called in all GTK applications.  arguments are parsed from
     * the command line and are returned to the application. */
    gtk_init (&argc, &argv);

    /* create a new window */
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

    /* this is a new call, this just sets the title of our
     * new window to "Hello Buttons!" */
    gtk_window_set_title (GTK_WINDOW (window), "GTKCtrlAltDel");

    /* Here we just set a handler for delete_event that immediately
     * exits GTK. */
    gtk_signal_connect (GTK_OBJECT (window), "delete_event",
                        GTK_SIGNAL_FUNC (delete_event), NULL);


    /* sets the border width of the window. */
    gtk_container_border_width (GTK_CONTAINER (window), 10);

    /* we create a box to pack widgets into.  this is described in detail
     * in the "packing" section below.  The box is not really visible, it
     * is just used as a tool to arrange widgets. */
    box1 = gtk_hbox_new(FALSE, 0);

    /* put the box into the main window. */
    gtk_container_add (GTK_CONTAINER (window), box1);

    tooltips = gtk_tooltips_new();


    /* creates a new button with the label "Button 1". */
    button1 = gtk_toggle_button_new_with_label ("Ctrl");

    gtk_tooltips_set_tip(tooltips, button1, "Click to press CTRL", NULL);


    /* Now when the button is clicked, we call the "callback" function
     * with a pointer to "button 1" as it's argument */
    gtk_signal_connect (GTK_OBJECT (button1), "clicked",
                        GTK_SIGNAL_FUNC (ctrl_callback), (gpointer) "button 1");

    /* instead of gtk_container_add, we pack this button into the invisible
     * box, which has been packed into the window. */
    gtk_box_pack_start(GTK_BOX(box1), button1, TRUE, TRUE, 0);

    /* always remember this step, this tells GTK that our preparation for
     * this button is complete, and it can be displayed now. */
    gtk_widget_show(button1);

    /* do these same steps again to create a second button */
    button2 = gtk_toggle_button_new_with_label ("Alt");

    gtk_tooltips_set_tip(tooltips, button2, "Click to press ALT", NULL);

    /* call the same callback function with a different argument,
     * passing a pointer to "button 2" instead. */
    gtk_signal_connect (GTK_OBJECT (button2), "clicked",
                        GTK_SIGNAL_FUNC (alt_callback), (gpointer) "button 2");

    gtk_box_pack_start(GTK_BOX(box1), button2, TRUE, TRUE, 0);

    gtk_widget_show(button2);

    /* creates a new button with the label "Button 3". */
    button3 = gtk_toggle_button_new_with_label ("Del");

    gtk_tooltips_set_tip(tooltips, button3, "Click to press DEL", NULL);

    gtk_signal_connect (GTK_OBJECT (button3), "clicked",
                        GTK_SIGNAL_FUNC (del_callback), (gpointer) "button 3");

    gtk_box_pack_start(GTK_BOX(box1), button3, TRUE, TRUE, 0);

    /* always remember this step, this tells GTK that our preparation for
     * this button is complete, and it can be displayed now. */
    gtk_widget_show(button3);

    gtk_widget_show(box1);

    gtk_widget_show (window);

    gtk_main ();

    return 0;
}
/* example-end */
